// LB_API2_32_64.cpp : Defines the exported functions for the DLL application.
//
#include "stdafx.h"
// Comment out the next line for troubleshooting purposes ONLY!
#define AUTO_START_SERVER
#define SOCKET_NOT_STARTED 0
#define SOCKET_IS_STARTED 1

#define SOCKET_LEN 20
char portNumber[SOCKET_LEN] = {0};
char currDir[MAX_PATH];
char iniDirFile[MAX_PATH];
char serverDirFile[MAX_PATH];

static int socketStarted = SOCKET_NOT_STARTED;
static int restarting = 0;

struct _RegInfo
{
    char altPath_1[MAX_PATH];
    char altPath_2[MAX_PATH];
    char altPath_3[MAX_PATH];
    char defaultPath[MAX_PATH];
    char socketNumber[MAX_PATH];
    char trueFalseMakeServerVisible[MAX_PATH];
    char trueFalseStartServer[MAX_PATH];
    char trueFalseUseINIFile[MAX_PATH];
    char trueValue[MAX_PATH];
    char falseValue[MAX_PATH];
} typedef regInfo;

long rslt = 0;
long buffLen = MAX_PATH;
regInfo ri;

//====================================================================================================================
long UseRegistry()
{
    WIN32_FIND_DATA ffd;

    rslt = RegQueryValueA(HKEY_CURRENT_USER,"Software\\LadyBug\\AlternatePaths\\1",ri.altPath_1,(PLONG)&buffLen);
    if (rslt != ERROR_SUCCESS)
    {
        memset(ri.altPath_1,0,MAX_PATH);
    };
    buffLen = MAX_PATH;
    rslt = RegQueryValueA(HKEY_CURRENT_USER,"Software\\LadyBug\\AlternatePaths\\2",ri.altPath_2,(PLONG)&buffLen);
    if (rslt != ERROR_SUCCESS)
    {
        memset(ri.altPath_1,0,MAX_PATH);
    };
    buffLen = MAX_PATH;
    rslt = RegQueryValueA(HKEY_CURRENT_USER,"Software\\LadyBug\\AlternatePaths\\3",ri.altPath_3,(PLONG)&buffLen);
    if (rslt != ERROR_SUCCESS)
    {
        memset(ri.altPath_1,0,MAX_PATH);
    };
    buffLen = MAX_PATH;
    rslt = RegQueryValueA(HKEY_CURRENT_USER,"Software\\LadyBug\\DefaultPath",ri.defaultPath,(PLONG)&buffLen);
    if (rslt != ERROR_SUCCESS)
    {
        memset(ri.altPath_1,0,MAX_PATH);
    };
    buffLen = MAX_PATH;
    rslt = RegQueryValueA(HKEY_CURRENT_USER,"Software\\LadyBug\\SocketNumber",ri.socketNumber,(PLONG)&buffLen);
    if (rslt != ERROR_SUCCESS)
    {
        memset(ri.altPath_1,0,MAX_PATH);
    };
    buffLen = MAX_PATH;
    rslt = RegQueryValueA(HKEY_CURRENT_USER,"Software\\LadyBug\\TrueFalseMakeServerVisible",ri.trueFalseMakeServerVisible,(PLONG)&buffLen);
    if (rslt != ERROR_SUCCESS)
    {
        memset(ri.altPath_1,0,MAX_PATH);
    };
    buffLen = MAX_PATH;
    rslt = RegQueryValueA(HKEY_CURRENT_USER,"Software\\LadyBug\\TrueFalseStartServer",ri.trueFalseStartServer,(PLONG)&buffLen);
    if (rslt != ERROR_SUCCESS)
    {
        memset(ri.altPath_1,0,MAX_PATH);
    };
    buffLen = MAX_PATH;
    rslt = RegQueryValueA(HKEY_CURRENT_USER,"Software\\LadyBug\\TrueFalseUseINIFile",ri.trueFalseUseINIFile,(PLONG)&buffLen);
    if (rslt != ERROR_SUCCESS)
    {
        memset(ri.altPath_1,0,MAX_PATH);
    };
    buffLen = MAX_PATH;
    rslt = RegQueryValueA(HKEY_CURRENT_USER,"Software\\LadyBug\\TrueFalseValues\\FalseValue",ri.falseValue,(PLONG)&buffLen);
    if (rslt != ERROR_SUCCESS)
    {
        memset(ri.altPath_1,0,MAX_PATH);
    };
    buffLen = MAX_PATH;
    rslt = RegQueryValueA(HKEY_CURRENT_USER,"Software\\LadyBug\\TrueFalseValues\\TrueValue",ri.trueValue,(PLONG)&buffLen);
    if (rslt != ERROR_SUCCESS)
    {
        memset(ri.altPath_1,0,MAX_PATH);
    };
    if (ri.trueFalseUseINIFile==ri.trueValue)
    {
        return 0;
    }
    rslt = GetFileAttributesA(ri.defaultPath);
    if (rslt == FILE_ATTRIBUTE_DIRECTORY)
        return 1;
    else
        return 0;
}

//====================================================================================================================
LB_API2_32_64_API StartSocket(void)
{
    long rslt;
    long startServer = 0;

    if (socketStarted == SOCKET_IS_STARTED)
    {
        return 1;                                                   // don't restart the socket if it's already started
    }
    else
    {
        rslt = GetCurrentDirectoryA(MAX_PATH, (LPSTR)iniDirFile);       // get the current directory
        rslt = GetCurrentDirectoryA(MAX_PATH, (LPSTR)serverDirFile);    // get the current directory again...need a second copy
        strcat(iniDirFile, INI_FILE_NAME);                              // append the ini file name...note double slash required for C/C++ strings
        strcat(serverDirFile, SERVER_FILE_NAME);                        // append the server file name...note double slash required for C/C++ strings
        startServer = GetPrivateProfileIntA("STARTSERVER","START",1,iniDirFile);
#ifdef AUTO_START_SERVER
        if (startServer==1)
        {
            if (restarting==0)
            {
                rslt = GetPrivateProfileStringA("COMM","SOCKET",DEFAULT_PORT,portNumber,(DWORD)20,iniDirFile);  // query the ini file for the preferred socket
                ShellExecuteA(NULL,NULL,serverDirFile,NULL,NULL,SW_SHOWNOACTIVATE);
                Sleep(250);                                                     // gives things a little time to settle out...
            }
        }
        else
        {
            rslt = GetPrivateProfileStringA("COMM","SOCKET",DEFAULT_PORT,portNumber,(DWORD)20,iniDirFile);  // query the ini file for the preferred socket
        }
        restarting = 0;
#else
#endif
    }
    if (!client.Start())
    {
        socketStarted = SOCKET_NOT_STARTED;
        return ERR_UNK;
    }
    else
    {
        socketStarted = SOCKET_IS_STARTED;
    }
	return 1;
}

//====================================================================================================================
LB_API2_32_64_API StopSocket(void)
{
    if (socketStarted==SOCKET_IS_STARTED) 
        client.Stop();
    socketStarted = SOCKET_NOT_STARTED;
    return 1;
}

//====================================================================================================================
LB_API2_32_64_API StopRestartSocket(void)
{
    int rslt = 0;
    if (socketStarted==SOCKET_IS_STARTED) 
    {
        rslt = LB_CloseRestartSocketServerSocket();
        client.Stop();
        socketStarted = SOCKET_NOT_STARTED;
        restarting = 1;
        Sleep(1000);
    }
    rslt = StartSocket();
    return 1;
}

//====================================================================================================================
LB_API2_32_64_API StartSocketExplicit(char* path, char* socketNum)
{
    long rslt;
    long startServer = 1;

    if (socketStarted == SOCKET_IS_STARTED)
    {
        return 1;                                                   // don't restart the socket if it's already started
    };
    strncpy(iniDirFile, path,MAX_PATH);
    strncpy(serverDirFile, path,MAX_PATH);
    strcat(iniDirFile, INI_FILE_NAME);                              // append the ini file name...note double slash required for C/C++ strings
    strcat(serverDirFile, SERVER_FILE_NAME);                        // append the server file name...note double slash required for C/C++ strings
    strncpy(portNumber, socketNum, SOCKET_LEN);
    ShellExecuteA(NULL,NULL,serverDirFile,socketNum,path,SW_SHOWNOACTIVATE);
    if (!client.Start())
    {
        socketStarted = SOCKET_NOT_STARTED;
        return ERR_UNK;
    }
    else
    {
        socketStarted = SOCKET_IS_STARTED;
    }
	return 1;
}

