#define WIN32_LEAN_AND_MEAN
 
#include "main.h"

// link with Ws2_32.lib
#pragma comment(lib, "Ws2_32.lib")
 
// #define DEFAULT_PORT "27015"
#define DEFAULT_BUFFER_LENGTH    8192
char portNumber[20] = {0};

char rcvBuff[DEFAULT_BUFFER_LENGTH];
normalPkg_t pSndNmlPkg;
normalPkg_t pRcvNmlPkg;
rspPtsPkg_t pSndRspPkg;
rspPtsPkg_t pRcvRspPkg;
long closeAndRestart_LB_SocketServerSocket = 0;
long close_LB_SocketServerApplication = 0;

struct _RegInfo
{
    char altPath_1[MAX_PATH];
    char altPath_2[MAX_PATH];
    char altPath_3[MAX_PATH];
    char defaultPath[MAX_PATH];
    char socketNumber[MAX_PATH];
    char trueFalseMakeServerVisible[MAX_PATH];
    char trueFalseStartServer[MAX_PATH];
    char trueFalseUseINIFile[MAX_PATH];
    char trueValue[MAX_PATH];
    char falseValue[MAX_PATH];
} typedef regInfo;

long rslt = 0;
long buffLen = MAX_PATH;
regInfo ri;

//====================================================================================================================
long UseRegistry()
{
    WIN32_FIND_DATA ffd;

    rslt = RegQueryValueA(HKEY_CURRENT_USER,"Software\\LadyBug\\AlternatePaths\\1",ri.altPath_1,(PLONG)&buffLen);
    if (rslt != ERROR_SUCCESS)
    {
        memset(ri.altPath_1,0,MAX_PATH);
    };
    buffLen = MAX_PATH;
    rslt = RegQueryValueA(HKEY_CURRENT_USER,"Software\\LadyBug\\AlternatePaths\\2",ri.altPath_2,(PLONG)&buffLen);
    if (rslt != ERROR_SUCCESS)
    {
        memset(ri.altPath_1,0,MAX_PATH);
    };
    buffLen = MAX_PATH;
    rslt = RegQueryValueA(HKEY_CURRENT_USER,"Software\\LadyBug\\AlternatePaths\\3",ri.altPath_3,(PLONG)&buffLen);
    if (rslt != ERROR_SUCCESS)
    {
        memset(ri.altPath_1,0,MAX_PATH);
    };
    buffLen = MAX_PATH;
    rslt = RegQueryValueA(HKEY_CURRENT_USER,"Software\\LadyBug\\DefaultPath",ri.defaultPath,(PLONG)&buffLen);
    if (rslt != ERROR_SUCCESS)
    {
        memset(ri.altPath_1,0,MAX_PATH);
    };
    buffLen = MAX_PATH;
    rslt = RegQueryValueA(HKEY_CURRENT_USER,"Software\\LadyBug\\SocketNumber",ri.socketNumber,(PLONG)&buffLen);
    if (rslt != ERROR_SUCCESS)
    {
        memset(ri.altPath_1,0,MAX_PATH);
    };
    buffLen = MAX_PATH;
    rslt = RegQueryValueA(HKEY_CURRENT_USER,"Software\\LadyBug\\TrueFalseMakeServerVisible",ri.trueFalseMakeServerVisible,(PLONG)&buffLen);
    if (rslt != ERROR_SUCCESS)
    {
        memset(ri.altPath_1,0,MAX_PATH);
    };
    buffLen = MAX_PATH;
    rslt = RegQueryValueA(HKEY_CURRENT_USER,"Software\\LadyBug\\TrueFalseStartServer",ri.trueFalseStartServer,(PLONG)&buffLen);
    if (rslt != ERROR_SUCCESS)
    {
        memset(ri.altPath_1,0,MAX_PATH);
    };
    buffLen = MAX_PATH;
    rslt = RegQueryValueA(HKEY_CURRENT_USER,"Software\\LadyBug\\TrueFalseUseINIFile",ri.trueFalseUseINIFile,(PLONG)&buffLen);
    if (rslt != ERROR_SUCCESS)
    {
        memset(ri.altPath_1,0,MAX_PATH);
    };
    buffLen = MAX_PATH;
    rslt = RegQueryValueA(HKEY_CURRENT_USER,"Software\\LadyBug\\TrueFalseValues\\FalseValue",ri.falseValue,(PLONG)&buffLen);
    if (rslt != ERROR_SUCCESS)
    {
        memset(ri.altPath_1,0,MAX_PATH);
    };
    buffLen = MAX_PATH;
    rslt = RegQueryValueA(HKEY_CURRENT_USER,"Software\\LadyBug\\TrueFalseValues\\TrueValue",ri.trueValue,(PLONG)&buffLen);
    if (rslt != ERROR_SUCCESS)
    {
        memset(ri.altPath_1,0,MAX_PATH);
    };
    if (atoi(ri.trueFalseUseINIFile)==atoi(ri.trueValue))
    {
        return 0;
    }
    rslt = GetFileAttributesA(ri.defaultPath);
    if (rslt == FILE_ATTRIBUTE_DIRECTORY)
        return 1;
    else
        return 0;
}

int main(int argc, char ** argv) 
{
    char currDir[MAX_PATH];                             
    long rslt = 0;
    long lngUseRegistry = 0;
    int makeConsoleVisible = 0;                         


    // look in the ini file to see wether or not to shown the console
    closeAndRestart_LB_SocketServerSocket = 0;
    close_LB_SocketServerApplication = 0;
    rslt = GetCurrentDirectoryA(MAX_PATH, (LPSTR)currDir);          // get the current directory
    if (argc > 1)
    {
        makeConsoleVisible = 0;
        strcpy(portNumber,argv[1]);
    }
    else
    {
        lngUseRegistry = UseRegistry();
        if (lngUseRegistry) 
        {
            strcat(ri.defaultPath, INI_FILE_NAME);                                      // append the file name...note double slash required by C++
            makeConsoleVisible = ri.trueFalseMakeServerVisible==ri.trueValue;   // query the ini file for the preferred state of the console
            strcpy(portNumber,ri.socketNumber);
        }
        else
        {
            strcat(currDir, INI_FILE_NAME);                                 // append the file name...note double slash required by C++
            makeConsoleVisible = GetPrivateProfileIntA("VISIBLE","STATE",0, currDir);   // query the ini file for the preferred state of the console
            rslt = GetPrivateProfileStringA("COMM","SOCKET",DEFAULT_PORT,portNumber,(DWORD)20,currDir);   // query the ini file for the preferred state of the console
        }
    }
    if (!makeConsoleVisible)
        FreeConsole();                                              // do not show the console...executable shows up in task manager processes so it can be stopped by user
    else
        printf("To hide console set\n\n[VISIBLE]\nSTATE=0\n\nin .. INI file lb_api2_32_64.ini\n");

    do
    {
         // Initialize Winsock
        WSADATA wsaData;
        int iRcvResult = WSAStartup(MAKEWORD(2,2), &wsaData);
        int sendRslt = 0;

        if(iRcvResult != 0)
        {
            printf("WSAStartup failed: %d\n", iRcvResult);
            return 1;
        }
 
        struct addrinfo *result = NULL, hints;
 
        ZeroMemory(&hints, sizeof(hints));
        hints.ai_family = AF_INET;              // Internet address family is unspecified so that either an IPv6 or IPv4 address can be returned
        hints.ai_socktype = SOCK_STREAM;        // Requests the socket type to be a stream socket for the TCP protocol
        hints.ai_protocol = IPPROTO_TCP;
        hints.ai_flags = AI_PASSIVE;
 
        // Resolve the local address and port to be used by the server
        iRcvResult = getaddrinfo(NULL, portNumber, &hints, &result);
        if (iRcvResult != 0)
        {
            printf("getaddrinfo failed: %d\n", iRcvResult);
            WSACleanup();
            return 1;
        }
        
        printf("\n\nListening on port number %s....\n", portNumber);
        SOCKET ListenSocket = INVALID_SOCKET;
 
        // Create a SOCKET for the server to listen for client connections
        ListenSocket = socket(result->ai_family, result->ai_socktype, result->ai_protocol);
 
        if (ListenSocket == INVALID_SOCKET)
        {
            printf("Error at socket(): %d\n", WSAGetLastError());
            freeaddrinfo(result);
            WSACleanup();
            return 1;
        }
 
        // Setup the TCP listening socket
        iRcvResult = bind(ListenSocket, result->ai_addr,  (int)result->ai_addrlen);
 
        if (iRcvResult == SOCKET_ERROR)
        {
            printf("bind failed: %d", WSAGetLastError());
            freeaddrinfo(result);
            closesocket(ListenSocket);
            WSACleanup();
            return 1;
        }
 
        freeaddrinfo(result);
 
        // To listen on a socket
        if ( listen(ListenSocket, SOMAXCONN) == SOCKET_ERROR)
        {
            printf("listen failed: %d\n", WSAGetLastError());
            closesocket(ListenSocket);
            WSACleanup();
            return 1;
        }
 
        SOCKET ServerSocket;
        ServerSocket = INVALID_SOCKET;
 
        // Accept a client socket
        ServerSocket = accept(ListenSocket, NULL, NULL);
 
        if (ServerSocket == INVALID_SOCKET)
        {
            printf("accept failed: %d\n", WSAGetLastError());
            closesocket(ListenSocket);
            WSACleanup();
            return 1;
        }
    
        // pkg_t pkg;
        int iSendResult;

        // reveice until the client shutdown the connection
        do 
        {
            long callId;
            memset(rcvBuff, 0, DEFAULT_BUFFER_LENGTH);
            iRcvResult = recv(ServerSocket, rcvBuff, DEFAULT_BUFFER_LENGTH, 0);
            if (iRcvResult > 0)
            {
                if (iRcvResult<=NORMAL_PACKAGE_SIZE)
                {
                    memcpy(&pRcvNmlPkg, rcvBuff, iRcvResult);
                    pRcvNmlPkg.basInf.nEventId = ~pRcvNmlPkg.basInf.eventId;
                    callId = pRcvNmlPkg.basInf.callId;
                }
                else
                {
                    memcpy(&pRcvRspPkg, rcvBuff, iRcvResult);
                    pRcvNmlPkg.basInf.nEventId = ~pRcvNmlPkg.basInf.eventId;
                    callId = pRcvRspPkg.basInf.callId;
                }
                printf("received %i bytes, callId = %i...\n",iRcvResult, callId);
                switch (callId)
                {
                case _LB_DriverVersion:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_DriverVersion();
                    break;
                    }
                case _LB_SensorCnt:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_SensorCnt();                             
                    break;
                    }
                case _LB_BlinkLED_SN:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_BlinkLED_SN(pRcvNmlPkg.basInf.sn);                             
                    break;
                    }
                case _LB_BlinkLED_Addr:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_BlinkLED_Addr(pRcvNmlPkg.basInf.addr);                             
                    break;
                    }
                case _LB_BlinkLED_Idx:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_BlinkLED_Idx(pRcvNmlPkg.basInf.idx);                             
                    break;
                    }
                case _LB_SensorList:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_SensorList((SensorDescrption*)pRcvNmlPkg.sd.sd,(long)pRcvNmlPkg.sd.cnt);
                    break;
                    }
                case _LB_GetAddress_SN:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetAddress_SN(pRcvNmlPkg.basInf.sn);
                    break;
                    }
                case _LB_GetAddress_Idx:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetAddress_Idx(pRcvNmlPkg.basInf.idx);
                    break;
                    }
                case _LB_SetAddress_SN:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_SetAddress_SN(pRcvNmlPkg.basInf.sn,pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_AddressConflictExists:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_AddressConflictExists();
                    break;
                    }
                case _LB_WillAddressConflict:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_WillAddressConflict(pRcvNmlPkg.basInf.addr);
                    break;
                    }
                case _LB_GetSerNo_Addr:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetSerNo_Addr(pRcvNmlPkg.basInf.addr,pRcvNmlPkg.prms.sns.snOne);
                    break;
                    }
                case _LB_ChangeAddress:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_ChangeAddress(pRcvNmlPkg.basInf.addr,pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_GetModelNumber_SN:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetModelNumber_SN(pRcvNmlPkg.basInf.sn,(MODEL_NUMBER*)&pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_GetModelNumber_Addr:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetModelNumber_Addr((long)pRcvNmlPkg.basInf.addr,(MODEL_NUMBER*)&pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_IsSensorConnected_SN:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_IsSensorConnected_SN(pRcvNmlPkg.basInf.sn);
                    break;
                    }
                case _LB_IsSensorConnected_Addr:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_IsSensorConnected_Addr(pRcvNmlPkg.basInf.addr);
                    break;
                    }
                case _LB_SetAutoPulseEnabled:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_SetAutoPulseEnabled(pRcvNmlPkg.basInf.addr,(FEATURE_STATE)pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_GetAutoPulseEnabled:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetAutoPulseEnabled(pRcvNmlPkg.basInf.addr,(FEATURE_STATE*)&pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_SetCWReference:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_SetCWReference(pRcvNmlPkg.basInf.addr,pRcvNmlPkg.prms.dbls[0],(PWR_UNITS)pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_GetCWReference:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetCWReference(pRcvNmlPkg.basInf.addr,&pRcvNmlPkg.prms.dbls[0],(PWR_UNITS*)&pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_SetDoubleSidedLimit:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_SetDoubleSidedLimit(pRcvNmlPkg.basInf.addr,pRcvNmlPkg.prms.dbls[0],pRcvNmlPkg.prms.dbls[1],(PWR_UNITS)pRcvNmlPkg.prms.longs[0],(DS_RULE)pRcvNmlPkg.prms.longs[1]);
                    break;
                    }
                case _LB_GetDoubleSidedLimit:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetDoubleSidedLimit(pRcvNmlPkg.basInf.addr,&pRcvNmlPkg.prms.dbls[0],&pRcvNmlPkg.prms.dbls[1],(PWR_UNITS*)&pRcvNmlPkg.prms.longs[0],(DS_RULE*)&pRcvNmlPkg.prms.longs[1]);
                    break;
                    }
                case _LB_SetDutyCycleEnabled:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_SetDutyCycleEnabled(pRcvNmlPkg.basInf.addr,(FEATURE_STATE)pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_GetDutyCycleEnabled:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetDutyCycleEnabled(pRcvNmlPkg.basInf.addr,(FEATURE_STATE*)&pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_SetDutyCyclePerCent:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_SetDutyCyclePerCent(pRcvNmlPkg.basInf.addr,pRcvNmlPkg.prms.dbls[0]);
                    break;
                    }
                case _LB_GetDutyCyclePerCent:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetDutyCyclePerCent(pRcvNmlPkg.basInf.addr,&pRcvNmlPkg.prms.dbls[0]);
                    break;
                    }
                case _LB_GetFirmwareVersion:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetFirmwareVersion(pRcvNmlPkg.basInf.addr,pRcvNmlPkg.prms.sns.snOne,pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_GetIndex_SN:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetIndex_SN(pRcvNmlPkg.basInf.sn);
                    break;
                    }
                case _LB_GetIndex_Addr:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetIndex_Addr(pRcvNmlPkg.basInf.addr);
                    break;
                    }
                case _LB_SetLimitEnabled:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_SetLimitEnabled(pRcvNmlPkg.basInf.addr,(LIMIT_STYLE)pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_GetLimitEnabled:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetLimitEnabled(pRcvNmlPkg.basInf.addr,(LIMIT_STYLE*)&pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_SetMeasurementPowerUnits:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_SetMeasurementPowerUnits(pRcvNmlPkg.basInf.addr,(PWR_UNITS)pRcvNmlPkg.prms.longs[0]);                             
                    break;
                    }
                case _LB_GetMeasurementPowerUnits:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetMeasurementPowerUnits(pRcvNmlPkg.basInf.addr,(PWR_UNITS*)&pRcvNmlPkg.prms.longs[0]);                             
                    break;
                    }
                case _LB_GetModelNumber_Idx:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetModelNumber_Idx((long)pRcvNmlPkg.basInf.idx,(MODEL_NUMBER*)&pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_SetOffsetEnabled:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_SetOffsetEnabled(pRcvNmlPkg.basInf.addr,(FEATURE_STATE)pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_GetOffsetEnabled:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetOffsetEnabled(pRcvNmlPkg.basInf.addr,(FEATURE_STATE*)&pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_SetPulseReference:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_SetPulseReference(pRcvNmlPkg.basInf.addr,pRcvNmlPkg.prms.dbls[0],pRcvNmlPkg.prms.dbls[1],pRcvNmlPkg.prms.dbls[2],pRcvNmlPkg.prms.dbls[3],(PWR_UNITS)pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_GetPulseReference:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetPulseReference(pRcvNmlPkg.basInf.addr,&pRcvNmlPkg.prms.dbls[0],&pRcvNmlPkg.prms.dbls[1],&pRcvNmlPkg.prms.dbls[2],&pRcvNmlPkg.prms.dbls[3],(PWR_UNITS*)&pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_SetResponseEnabled:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_SetResponseEnabled(pRcvNmlPkg.basInf.addr,(FEATURE_STATE)pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_GetResponseEnabled:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetResponseEnabled(pRcvNmlPkg.basInf.addr,(FEATURE_STATE*)&pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_SetResponse:
                    {
                    pRcvRspPkg.basInf.result = (int)LB_SetResponse(pRcvRspPkg.basInf.addr, 
                        (ResponsePoints*)&pRcvRspPkg.rPts.pts[0],
                        pRcvRspPkg.rPts.cnt);
                    break;
                    }
                case _LB_SetResponse_Flat:
                    {
                    pRcvRspPkg.basInf.result = (int)LB_SetResponse_Flat(pRcvRspPkg.basInf.addr, 
                        &pRcvRspPkg.rPtsFlat.frequency[0],
                        &pRcvRspPkg.rPtsFlat.amplitude[0],
                        pRcvRspPkg.rPtsFlat.cnt);
                    break;
                    }
                case _LB_GetResponse:
                    {
                    pRcvRspPkg.basInf.result = (int)LB_GetResponse(pRcvRspPkg.basInf.addr, 
                        (ResponsePoints*)&pRcvRspPkg.rPts.pts[0],
                        &pRcvRspPkg.rPts.cnt);
                    break;
                    }
                case _LB_GetResponse_Flat:
                    {
                    pRcvRspPkg.basInf.result = (int)LB_GetResponse_Flat(pRcvRspPkg.basInf.addr, 
                        &pRcvRspPkg.rPtsFlat.frequency[0],
                        &pRcvRspPkg.rPtsFlat.amplitude[0],
                        &pRcvRspPkg.rPtsFlat.cnt);
                    break;
                    }
                case _LB_GetSerNo_Idx:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetSerNo_Idx(pRcvNmlPkg.basInf.idx,pRcvNmlPkg.prms.sns.snOne);
                    break;
                    }
                case _LB_SetSingleSidedLimit:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_SetSingleSidedLimit(pRcvNmlPkg.basInf.addr,pRcvNmlPkg.prms.dbls[0],(PWR_UNITS)pRcvNmlPkg.prms.longs[0],(SS_RULE)pRcvNmlPkg.prms.longs[1]);
                    break;
                    }
                case _LB_GetSingleSidedLimit:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetSingleSidedLimit(pRcvNmlPkg.basInf.addr,&pRcvNmlPkg.prms.dbls[0],(PWR_UNITS*)&pRcvNmlPkg.prms.longs[0],(SS_RULE*)&pRcvNmlPkg.prms.longs[1]);
                    break;
                    }
                case _LB_InitializeSensor_Idx:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_InitializeSensor_Idx(pRcvNmlPkg.basInf.idx);                             
                    break;
                    }
                case _LB_MeasureCW_PF:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_MeasureCW_PF(pRcvNmlPkg.basInf.addr,&pRcvNmlPkg.prms.dbls[0],(PASS_FAIL_RESULT*)&pRcvNmlPkg.prms.longs[0]);                             
                    break;
                    }
                case _LB_MeasurePulse_PF:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_MeasurePulse_PF(pRcvNmlPkg.basInf.addr,&pRcvNmlPkg.prms.dbls[0],&pRcvNmlPkg.prms.dbls[1],&pRcvNmlPkg.prms.dbls[2],&pRcvNmlPkg.prms.dbls[3],(PASS_FAIL_RESULT*)&pRcvNmlPkg.prms.longs[0]);                             
                    break;
                    }
                case _LB_ReadStateFromINI:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_ReadStateFromINI(pRcvNmlPkg.basInf.addr);
                    break;
                    }
                case _LB_WriteStateToINI:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_WriteStateToINI(pRcvNmlPkg.basInf.addr);
                    break;
                    }
                case _LB_Recall:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_Recall(pRcvNmlPkg.basInf.addr,pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_Store:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_Store(pRcvNmlPkg.basInf.addr,pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_ResetCurrentState:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_ResetCurrentState(pRcvNmlPkg.basInf.addr);
                    break;
                    }
                case _LB_ResetRegStates:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_ResetRegStates(pRcvNmlPkg.basInf.addr);
                    break;
                    }
                case _LB_SetAddress_Idx:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_SetAddress_Idx(pRcvNmlPkg.basInf.idx,pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_SetOffset:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_SetOffset(pRcvNmlPkg.basInf.addr,pRcvNmlPkg.prms.dbls[0]);
                    break;
                    }
                case _LB_GetOffset:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetOffset(pRcvNmlPkg.basInf.addr,&pRcvNmlPkg.prms.dbls[0]);
                    break;
                    }
                case _LB_SetCalDueDate:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_SetCalDueDate(pRcvNmlPkg.basInf.sn,pRcvNmlPkg.prms.longs[0],pRcvNmlPkg.prms.longs[1],pRcvNmlPkg.prms.longs[2]);
                    break;
                    }
                case _LB_GetCalDueDate:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetCalDueDate(pRcvNmlPkg.basInf.sn,&pRcvNmlPkg.prms.longs[0],&pRcvNmlPkg.prms.longs[1],&pRcvNmlPkg.prms.longs[2]);
                    break;
                    }
                case _LB_GetCalOptExpDate:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetCalOptExpDate(pRcvNmlPkg.basInf.sn,&pRcvNmlPkg.prms.longs[0],&pRcvNmlPkg.prms.longs[1],&pRcvNmlPkg.prms.longs[2]);
                    break;
                    }
                case _LB_GetWtyOptExpDate:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetWtyOptExpDate(pRcvNmlPkg.basInf.sn,&pRcvNmlPkg.prms.longs[0],&pRcvNmlPkg.prms.longs[1],&pRcvNmlPkg.prms.longs[2]);
                    break;
                    }
                case _LB_GetCalAndWtyOption:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetCalAndWtyOption(pRcvNmlPkg.basInf.sn,&pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_GetRecorderOutOption:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetRecorderOutOption(pRcvNmlPkg.basInf.sn,&pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_GetBestMatchOpt:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetBestMatchOpt(pRcvNmlPkg.basInf.sn,&pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_GetTriggerOpt:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetTriggerOpt(pRcvNmlPkg.basInf.sn,&pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_GetFilterOpt:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetFilterOpt(pRcvNmlPkg.basInf.sn,&pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_InitializeSensor_SN:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_InitializeSensor_SN(pRcvNmlPkg.basInf.sn);                             
                    break;
                    }
                case _LB_InitializeSensor_Addr:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_InitializeSensor_Addr(pRcvNmlPkg.basInf.addr);                             
                    break;
                    }
                case _LB_GetFrequency:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetFrequency(pRcvNmlPkg.basInf.addr,&pRcvNmlPkg.prms.dbls[0]);                             
                    break;
                    }
                case _LB_SetFrequency:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_SetFrequency(pRcvNmlPkg.basInf.addr,pRcvNmlPkg.prms.dbls[0]);                             
                    break;
                    }
                case _LB_GetAverages:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetAverages(pRcvNmlPkg.basInf.addr,&pRcvNmlPkg.prms.longs[0]);                             
                    break;
                    }
                case _LB_SetAverages:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_SetAverages(pRcvNmlPkg.basInf.addr,pRcvNmlPkg.prms.longs[0]);                             
                    break;
                    }
                case _LB_GetPulseCriteria:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetPulseCriteria(pRcvNmlPkg.basInf.addr,&pRcvNmlPkg.prms.dbls[0]);
                    break;
                    }
                case _LB_SetPulseCriteria:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_SetPulseCriteria(pRcvNmlPkg.basInf.addr,pRcvNmlPkg.prms.dbls[0]);
                    break;
                    }
                case _LB_GetTTLTriggerInEnabled:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetTTLTriggerInEnabled(pRcvNmlPkg.basInf.addr,(FEATURE_STATE*)&pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_SetTTLTriggerInEnabled:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_SetTTLTriggerInEnabled(pRcvNmlPkg.basInf.addr,(FEATURE_STATE)pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_GetTTLTriggerInInverted:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetTTLTriggerInInverted(pRcvNmlPkg.basInf.addr,(FEATURE_STATE*)&pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_SetTTLTriggerInInverted:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_SetTTLTriggerInInverted(pRcvNmlPkg.basInf.addr,(FEATURE_STATE)pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_GetTTLTriggerInTimeOut:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetTTLTriggerInTimeOut(pRcvNmlPkg.basInf.addr,&pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_SetTTLTriggerInTimeOut:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_SetTTLTriggerInTimeOut(pRcvNmlPkg.basInf.addr,pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_GetTTLTriggerOutEnabled:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetTTLTriggerOutEnabled(pRcvNmlPkg.basInf.addr,(FEATURE_STATE*)&pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_SetTTLTriggerOutEnabled:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_SetTTLTriggerOutEnabled(pRcvNmlPkg.basInf.addr,(FEATURE_STATE)pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_GetTTLTriggerOutInverted:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetTTLTriggerOutInverted(pRcvNmlPkg.basInf.addr,(FEATURE_STATE*)&pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_SetTTLTriggerOutInverted:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_SetTTLTriggerOutInverted(pRcvNmlPkg.basInf.addr,(FEATURE_STATE)pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_GetAntiAliasingEnabled:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetAntiAliasingEnabled(pRcvNmlPkg.basInf.addr,(FEATURE_STATE*)&pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_SetAntiAliasingEnabled:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_SetAntiAliasingEnabled(pRcvNmlPkg.basInf.addr,(FEATURE_STATE)pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_MeasureCW:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_MeasureCW(pRcvNmlPkg.basInf.addr,&pRcvNmlPkg.prms.dbls[0]);
                    break;
                    }
                case _LB_MeasurePulse:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_MeasurePulse(pRcvNmlPkg.basInf.addr,&pRcvNmlPkg.prms.dbls[0],&pRcvNmlPkg.prms.dbls[1],&pRcvNmlPkg.prms.dbls[2],&pRcvNmlPkg.prms.dbls[3]);
                    break;
                    }
                case _LB_GetExtendedAveragingEnabled:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetExtendedAveragingEnabled(pRcvNmlPkg.basInf.addr,(FEATURE_STATE*)&pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_SetExtendedAveragingEnabled:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_SetExtendedAveragingEnabled(pRcvNmlPkg.basInf.addr,(FEATURE_STATE)pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_GetExtendedAveraging:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetExtendedAveraging(pRcvNmlPkg.basInf.addr,&pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_SetExtendedAveraging:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_SetExtendedAveraging(pRcvNmlPkg.basInf.addr,pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_ResetExtendedAveraging:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_ResetExtendedAveraging(pRcvNmlPkg.basInf.addr);
                    break;
                    }
                case _LB_GetMaxHoldEnabled:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_GetMaxHoldEnabled(pRcvNmlPkg.basInf.addr,(FEATURE_STATE*)&pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_SetMaxHoldEnabled:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_SetMaxHoldEnabled(pRcvNmlPkg.basInf.addr,(FEATURE_STATE)pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_ResetMaxHold:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_ResetMaxHold(pRcvNmlPkg.basInf.addr);
                    break;
                    }
                case _LB_Get75OhmsEnabled:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_Get75OhmsEnabled(pRcvNmlPkg.basInf.addr,(FEATURE_STATE*)&pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_Set75OhmsEnabled:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_Set75OhmsEnabled(pRcvNmlPkg.basInf.addr,(FEATURE_STATE)pRcvNmlPkg.prms.longs[0]);
                    break;
                    }
                case _LB_IsDeviceInUse_Addr:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_IsDeviceInUse_Addr(pRcvNmlPkg.basInf.addr);
                    break;
                    }
                case _LB_IsDeviceInUse_SN:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_IsDeviceInUse_SN(pRcvNmlPkg.basInf.sn);
                    break;
                    }
                case _LB_MeasureBurst_DBM:
                    {
                    pRcvNmlPkg.basInf.result = (int)LB_MeasureBurst_DBM(pRcvNmlPkg.basInf.addr,pRcvNmlPkg.prms.longs[0],pRcvNmlPkg.prms.longs[1],pRcvNmlPkg.prms.longs[2],&pRcvNmlPkg.prms.dbls[0],&pRcvNmlPkg.prms.dbls[1],&pRcvNmlPkg.prms.dbls[2]);
                    break;
                    }
                case _LB_CloseRestartSocketServerSocket:
                    {
                    closeAndRestart_LB_SocketServerSocket = 1;
                    close_LB_SocketServerApplication = 0;
                    break;
                    }
                case _LB_CloseSocketServerApp:
                    {
                    closeAndRestart_LB_SocketServerSocket = 0;
                    close_LB_SocketServerApplication = 1;
                    }
                default:
                    {
                    break;
                    }
                };
                if ((closeAndRestart_LB_SocketServerSocket==0)&&(close_LB_SocketServerApplication==0))
                {
                    if (iRcvResult<=NORMAL_PACKAGE_SIZE)
                    {
                        memcpy(rcvBuff, &pRcvNmlPkg, iRcvResult);
                    }
                    else
                    {
                        memcpy(rcvBuff, &pRcvRspPkg, iRcvResult);
                    }
                    iSendResult = send(ServerSocket, rcvBuff, iRcvResult, 0);
                    printf("returned %i bytes...\n\n",iSendResult);

                    if (iSendResult == SOCKET_ERROR)
                    {
                        printf("send failed: %d\n", WSAGetLastError());
                        closeAndRestart_LB_SocketServerSocket = 0;
                        close_LB_SocketServerApplication = 1;
                        return 0;
                    }
                };
            }
            else
            {
                printf("Connection closed\n");
            }
        } while (iRcvResult>0);
        closesocket(ListenSocket);
        WSACleanup();
    } while (closeAndRestart_LB_SocketServerSocket==1);
    return 0;
}
