﻿'==================================================================================================
'Note: This doesn't have any error checking...didn't think it needed it. Pretty straight forward
'if the values are handled nicely.
'--------------------------------------------------------------------------------------------------
Public Class frmRegistryEditor
    Const pathKeyName As String = "HKEY_CURRENT_USER\Software\LadyBug\DefaultPath"
    Const socketNumberKeyName As String = "HKEY_CURRENT_USER\Software\LadyBug\SocketNumber"
    Const makeSensorVisibleKeyName As String = "HKEY_CURRENT_USER\Software\LadyBug\TrueFalseMakeServerVisible"
    Const startServerKeyName As String = "HKEY_CURRENT_USER\Software\LadyBug\TrueFalseStartServer"
    Const useINIFileKeyName As String = "HKEY_CURRENT_USER\Software\LadyBug\TrueFalseUseINIFile"
    Const falseValueKeyName As String = "HKEY_CURRENT_USER\Software\LadyBug\TrueFalseValues\FalseValue"
    Const trueValueKeyName As String = "HKEY_CURRENT_USER\Software\LadyBug\TrueFalseValues\TrueValue"
    Const defaultPath = "not set"
    Const defaultSocketString As String = "27713"
    Const falseValue_Reg As String = "0"                    'set to default false value
    Const trueValue_Reg As String = "1"                     'set to default true value
    Const falseIndex_List As Integer = 0                    'set to default false value
    Const trueIndex_List As Integer = 1                     'set to default true value
    Const falseValue_GUI As String = "FALSE"
    Const trueValue_GUI As String = "TRUE"

    Function InRangeInclusive(low As Integer, hi As Integer, val As Integer) As Boolean
        Return (val >= low) And (val <= hi)
    End Function

    Private Sub GetRegistryValues()
        Dim tmpString As String
        Dim tmpInt As Integer

        txtDefaultPath.Text = My.Computer.Registry.GetValue(pathKeyName, "", defaultPath)

        tmpString = My.Computer.Registry.GetValue(socketNumberKeyName, "", defaultSocketString)
        tmpInt = CInt(tmpString)
        If InRangeInclusive(10000, 60000, tmpInt) Then
            udSocketNumber.Value = tmpInt
        Else
            udSocketNumber.Value = CDec(defaultSocketString)
        End If

        tmpString = My.Computer.Registry.GetValue(startServerKeyName, "", trueValue_Reg)
        tmpInt = CInt(tmpString)
        If InRangeInclusive(0, 1, tmpInt) Then
            cboStartServer.SelectedIndex = tmpInt
        Else
            cboStartServer.SelectedIndex = trueIndex_List
        End If

        tmpString = My.Computer.Registry.GetValue(useINIFileKeyName, "", falseValue_Reg)
        tmpInt = CInt(tmpString)
        If InRangeInclusive(0, 1, tmpInt) Then
            cboUseINIFile.SelectedIndex = tmpInt
        Else
            cboUseINIFile.SelectedIndex = falseIndex_List
        End If

        tmpString = My.Computer.Registry.GetValue(makeSensorVisibleKeyName, "", falseValue_Reg)
        tmpInt = CInt(tmpString)
        If InRangeInclusive(0, 1, tmpInt) Then
            cboMakeServerVisible.SelectedIndex = tmpInt
        Else
            cboMakeServerVisible.SelectedIndex = falseIndex_List
        End If
    End Sub

    Private Sub SaveRegistryValues()
        My.Computer.Registry.SetValue(pathKeyName, "", txtDefaultPath.Text)
        My.Computer.Registry.SetValue(socketNumberKeyName, "", udSocketNumber.Value.ToString())
        My.Computer.Registry.SetValue(startServerKeyName, "", IIf(cboStartServer.SelectedIndex = 0, falseValue_Reg, trueValue_Reg))
        My.Computer.Registry.SetValue(useINIFileKeyName, "", IIf(cboUseINIFile.SelectedIndex = 0, falseValue_Reg, trueValue_Reg))
        My.Computer.Registry.SetValue(makeSensorVisibleKeyName, "", IIf(cboMakeServerVisible.SelectedIndex = 0, falseValue_Reg, trueValue_Reg))
        My.Computer.Registry.SetValue(trueValueKeyName, "", trueValue_Reg)
        My.Computer.Registry.SetValue(falseValueKeyName, "", falseValue_Reg)
    End Sub


    Private Sub btnGetRegistryEntries_Click(sender As System.Object, e As System.EventArgs) Handles btnGetRegistryEntries.Click
        GetRegistryValues()
    End Sub

    Private Sub frmRegistryEditor_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        GetRegistryValues()
    End Sub

    Private Sub btnSaveRegistryEntries_Click(sender As System.Object, e As System.EventArgs) Handles btnSaveRegistryEntries.Click
        SaveRegistryValues()
    End Sub
End Class
