#include <windows.h>
#include <stdlib.h>
#include <stdio.h>

#pragma comment(lib, "Ws2_32.lib")

#define MAX_PATH_BUFFER 255

struct _RegInfo
{
    char altPath_1[MAX_PATH_BUFFER];
    char altPath_2[MAX_PATH_BUFFER];
    char altPath_3[MAX_PATH_BUFFER];
    char defaultPath[MAX_PATH_BUFFER];
    char socketNumber[MAX_PATH_BUFFER];
    char trueFalseMakeServerVisible[MAX_PATH_BUFFER];
    char trueFalseStartServer[MAX_PATH_BUFFER];
    char trueFalseUseINIFile[MAX_PATH_BUFFER];
    char trueValue[MAX_PATH_BUFFER];
    char falseValue[MAX_PATH_BUFFER];
} typedef regInfo;

long rslt = 0;
long buffLen = MAX_PATH_BUFFER;
regInfo ri;

void GetRegistryValues()
{
    rslt = RegQueryValueA(HKEY_CURRENT_USER,"Software\\LadyBug\\AlternatePaths\\1",ri.altPath_1,(PLONG)&buffLen);
    if (rslt != ERROR_SUCCESS)
    {
        memset(ri.altPath_1,0,MAX_PATH_BUFFER);
    };
    buffLen = MAX_PATH_BUFFER;
    rslt = RegQueryValueA(HKEY_CURRENT_USER,"Software\\LadyBug\\AlternatePaths\\2",ri.altPath_2,(PLONG)&buffLen);
    if (rslt != ERROR_SUCCESS)
    {
        memset(ri.altPath_1,0,MAX_PATH_BUFFER);
    };
    buffLen = MAX_PATH_BUFFER;
    rslt = RegQueryValueA(HKEY_CURRENT_USER,"Software\\LadyBug\\AlternatePaths\\3",ri.altPath_3,(PLONG)&buffLen);
    if (rslt != ERROR_SUCCESS)
    {
        memset(ri.altPath_1,0,MAX_PATH_BUFFER);
    };
    buffLen = MAX_PATH_BUFFER;
    rslt = RegQueryValueA(HKEY_CURRENT_USER,"Software\\LadyBug\\DefaultPath",ri.defaultPath,(PLONG)&buffLen);
    if (rslt != ERROR_SUCCESS)
    {
        memset(ri.altPath_1,0,MAX_PATH_BUFFER);
    };
    buffLen = MAX_PATH_BUFFER;
    rslt = RegQueryValueA(HKEY_CURRENT_USER,"Software\\LadyBug\\SocketNumber",ri.socketNumber,(PLONG)&buffLen);
    if (rslt != ERROR_SUCCESS)
    {
        memset(ri.altPath_1,0,MAX_PATH_BUFFER);
    };
    buffLen = MAX_PATH_BUFFER;
    rslt = RegQueryValueA(HKEY_CURRENT_USER,"Software\\LadyBug\\TrueFalseMakeServerVisible",ri.trueFalseMakeServerVisible,(PLONG)&buffLen);
    if (rslt != ERROR_SUCCESS)
    {
        memset(ri.altPath_1,0,MAX_PATH_BUFFER);
    };
    buffLen = MAX_PATH_BUFFER;
    rslt = RegQueryValueA(HKEY_CURRENT_USER,"Software\\LadyBug\\TrueFalseStartServer",ri.trueFalseStartServer,(PLONG)&buffLen);
    if (rslt != ERROR_SUCCESS)
    {
        memset(ri.altPath_1,0,MAX_PATH_BUFFER);
    };
    buffLen = MAX_PATH_BUFFER;
    rslt = RegQueryValueA(HKEY_CURRENT_USER,"Software\\LadyBug\\TrueFalseUseINIFile",ri.trueFalseUseINIFile,(PLONG)&buffLen);
    if (rslt != ERROR_SUCCESS)
    {
        memset(ri.altPath_1,0,MAX_PATH_BUFFER);
    };
    buffLen = MAX_PATH_BUFFER;
    rslt = RegQueryValueA(HKEY_CURRENT_USER,"Software\\LadyBug\\TrueFalseValues\\FalseValue",ri.falseValue,(PLONG)&buffLen);
    if (rslt != ERROR_SUCCESS)
    {
        memset(ri.altPath_1,0,MAX_PATH_BUFFER);
    };
    buffLen = MAX_PATH_BUFFER;
    rslt = RegQueryValueA(HKEY_CURRENT_USER,"Software\\LadyBug\\TrueFalseValues\\TrueValue",ri.trueValue,(PLONG)&buffLen);
    if (rslt != ERROR_SUCCESS)
    {
        memset(ri.altPath_1,0,MAX_PATH_BUFFER);
    };
    rslt = GetFileAttributesA(ri.defaultPath);
    if (rslt == FILE_ATTRIBUTE_DIRECTORY)
        printf("found a valid directory\n");
    else
        printf("didn't find a valid directory\n");
}

int main()
{
    long rslt;
    long buffLen = MAX_PATH_BUFFER;
    char buff[MAX_PATH_BUFFER] = {0};

    GetRegistryValues();
    printf("path1 %s\n", ri.altPath_1);
    printf("path2 %s\n", ri.altPath_2);
    printf("path3 %s\n", ri.altPath_3);
    printf("default path %s\n", ri.defaultPath);
    printf("socket number %s\n", ri.socketNumber);
    printf("make server visible %s\n", ri.trueFalseMakeServerVisible);
    printf("start server %s\n", ri.trueFalseStartServer);
    printf("use INI file %s\n", ri.trueFalseUseINIFile);
    printf("true %s\n", ri.trueValue);
    printf("false %s\n", ri.falseValue);
    return 0;
}